
<script src="https://cdn.pydata.org/bokeh/release/bokeh-1.2.0.min.js" type="text/javascript"></script>
<script src="https://cdn.pydata.org/bokeh/release/bokeh-widgets-1.2.0.min.js" type="text/javascript"></script>
<script src="https://cdn.pydata.org/bokeh/release/bokeh-tables-1.2.0.min.js" type="text/javascript"></script>
<script src="https://cdn.pydata.org/bokeh/release/bokeh-gl-1.2.0.min.js" type="text/javascript"></script>
<script src="https://code.jquery.com/jquery-2.1.4.min.js" type="text/javascript"></script>
<script src="https://code.jquery.com/ui/1.10.4/jquery-ui.min.js" type="text/javascript"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.1.20/require.min.js" type="text/javascript"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/underscore.js/1.8.3/underscore-min.js" type="text/javascript"></script>
<script type="text/javascript">function HoloViewsWidget() {
}

HoloViewsWidget.prototype.init_slider = function(init_val){
  if(this.load_json) {
    this.from_json()
  } else {
    this.update_cache();
  }
}

HoloViewsWidget.prototype.populate_cache = function(idx){
  this.cache[idx].innerHTML = this.frames[idx];
  if (this.embed) {
    delete this.frames[idx];
  }
}

HoloViewsWidget.prototype.process_error = function(msg){
}

HoloViewsWidget.prototype.from_json = function() {
  var data_url = this.json_path + this.id + '.json';
  $.getJSON(data_url, $.proxy(function(json_data) {
    this.frames = json_data;
    this.update_cache();
    this.update(0);
  }, this));
}

HoloViewsWidget.prototype.dynamic_update = function(current){
  if (current === undefined) {
    return
  }
  this.current = current;
  if (this.comm) {
    var msg = {comm_id: this.id+'_client', content: current}
    this.comm.send(msg);
  }
}

HoloViewsWidget.prototype.update_cache = function(force){
  var frame_len = Object.keys(this.frames).length;
  for (var i=0; i<frame_len; i++) {
    if(!this.load_json || this.dynamic)  {
      var frame = Object.keys(this.frames)[i];
    } else {
      var frame = i;
    }
    if(!(frame in this.cache) || force) {
      if ((frame in this.cache) && force) { this.cache[frame].remove() }
      var div = document.createElement("div");
      var parent = document.getElementById("_anim_img"+this.id);
      div.style.display = "none";
      parent.appendChild(div)
      this.cache[frame] = div;
      var cache_id = "_anim_img"+this.id+"_"+frame;
      this.populate_cache(frame);
    }
  }
}

HoloViewsWidget.prototype.update = function(current){
  if(current in this.cache) {
    for (var index in this.cache) {
      this.cache[index].style.display = "none";
    }
    this.cache[current].style.display = "";
    this.wait = false;
  }
}

HoloViewsWidget.prototype.init_comms = function() {
  var that = this
  HoloViews.comm_manager.register_target(this.plot_id, this.id, function (msg) { that.msg_handler(msg) })
  if (!this.cached || this.dynamic) {
    function ack_callback(msg) {
      var msg = msg.metadata;
      var comm_id = msg.comm_id;
      var comm_status = HoloViews.comm_status[comm_id];
      if (that.queue.length > 0) {
        that.time = Date.now();
        that.dynamic_update(that.queue[that.queue.length-1]);
        that.queue = [];
      } else {
        that.wait = false;
      }
      if ((msg.msg_type == "Ready") && msg.content) {
        console.log("Python callback returned following output:", msg.content);
      } else if (msg.msg_type == "Error") {
        console.log("Python failed with the following traceback:", msg.traceback)
      }
    }
    var comm = HoloViews.comm_manager.get_client_comm(this.plot_id, this.id+'_client', ack_callback);
    return comm
  }
}

HoloViewsWidget.prototype.msg_handler = function(msg) {
  var metadata = msg.metadata;
  if ((metadata.msg_type == "Ready")) {
    if (metadata.content) {
      console.log("Python callback returned following output:", metadata.content);
    }
	return;
  } else if (metadata.msg_type == "Error") {
    console.log("Python failed with the following traceback:", metadata.traceback)
    return
  }
  this.process_msg(msg)
}

HoloViewsWidget.prototype.process_msg = function(msg) {
}

function SelectionWidget(frames, id, slider_ids, keyMap, dim_vals, notFound, load_json, mode, cached, json_path, dynamic, plot_id){
  this.frames = frames;
  this.id = id;
  this.plot_id = plot_id;
  this.slider_ids = slider_ids;
  this.keyMap = keyMap
  this.current_frame = 0;
  this.current_vals = dim_vals;
  this.load_json = load_json;
  this.mode = mode;
  this.notFound = notFound;
  this.cached = cached;
  this.dynamic = dynamic;
  this.cache = {};
  this.json_path = json_path;
  this.init_slider(this.current_vals[0]);
  this.queue = [];
  this.wait = false;
  if (!this.cached || this.dynamic) {
    this.comm = this.init_comms();
  }
}

SelectionWidget.prototype = new HoloViewsWidget;


SelectionWidget.prototype.get_key = function(current_vals) {
  var key = "(";
  for (var i=0; i<this.slider_ids.length; i++)
  {
    var val = this.current_vals[i];
    if (!(typeof val === 'string')) {
      if (val % 1 === 0) { val = val.toFixed(1); }
      else { val = val.toFixed(10); val = val.slice(0, val.length-1);}
    }
    key += "'" + val + "'";
    if(i != this.slider_ids.length-1) { key += ', ';}
    else if(this.slider_ids.length == 1) { key += ',';}
  }
  key += ")";
  return this.keyMap[key];
}

SelectionWidget.prototype.set_frame = function(dim_val, dim_idx){
  this.current_vals[dim_idx] = dim_val;
  var key = this.current_vals;
  if (!this.dynamic) {
    key = this.get_key(key)
  }
  if (this.dynamic || !this.cached) {
    if ((this.time !== undefined) && ((this.wait) && ((this.time + 10000) > Date.now()))) {
      this.queue.push(key);
      return
    }
    this.queue = [];
    this.time = Date.now();
    this.current_frame = key;
    this.wait = true;
    this.dynamic_update(key)
  } else if (key !== undefined) {
    this.update(key)
  }
}


/* Define the ScrubberWidget class */
function ScrubberWidget(frames, num_frames, id, interval, load_json, mode, cached, json_path, dynamic, plot_id){
  this.slider_id = "_anim_slider" + id;
  this.loop_select_id = "_anim_loop_select" + id;
  this.id = id;
  this.plot_id = plot_id;
  this.interval = interval;
  this.current_frame = 0;
  this.direction = 0;
  this.dynamic = dynamic;
  this.timer = null;
  this.load_json = load_json;
  this.mode = mode;
  this.cached = cached;
  this.frames = frames;
  this.cache = {};
  this.length = num_frames;
  this.json_path = json_path;
  document.getElementById(this.slider_id).max = this.length - 1;
  this.init_slider(0);
  this.wait = false;
  this.queue = [];
  if (!this.cached || this.dynamic) {
    this.comm = this.init_comms()
  }
}

ScrubberWidget.prototype = new HoloViewsWidget;

ScrubberWidget.prototype.set_frame = function(frame){
  this.current_frame = frame;
  var widget = document.getElementById(this.slider_id);
  if (widget === null) {
    this.pause_animation();
    return
  }
  widget.value = this.current_frame;
  if (this.dynamic || !this.cached) {
    if ((this.time !== undefined) && ((this.wait) && ((this.time + 10000) > Date.now()))) {
      this.queue.push(frame);
      return
    }
    this.queue = [];
    this.time = Date.now();
    this.wait = true;
    this.dynamic_update(frame)
  } else {
    this.update(frame)
  }
}

ScrubberWidget.prototype.get_loop_state = function(){
  var button_group = document[this.loop_select_id].state;
  for (var i = 0; i < button_group.length; i++) {
    var button = button_group[i];
    if (button.checked) {
      return button.value;
    }
  }
  return undefined;
}


ScrubberWidget.prototype.next_frame = function() {
  this.set_frame(Math.min(this.length - 1, this.current_frame + 1));
}

ScrubberWidget.prototype.previous_frame = function() {
  this.set_frame(Math.max(0, this.current_frame - 1));
}

ScrubberWidget.prototype.first_frame = function() {
  this.set_frame(0);
}

ScrubberWidget.prototype.last_frame = function() {
  this.set_frame(this.length - 1);
}

ScrubberWidget.prototype.slower = function() {
  this.interval /= 0.7;
  if(this.direction > 0){this.play_animation();}
  else if(this.direction < 0){this.reverse_animation();}
}

ScrubberWidget.prototype.faster = function() {
  this.interval *= 0.7;
  if(this.direction > 0){this.play_animation();}
  else if(this.direction < 0){this.reverse_animation();}
}

ScrubberWidget.prototype.anim_step_forward = function() {
  if(this.current_frame < this.length - 1){
    this.next_frame();
  }else{
    var loop_state = this.get_loop_state();
    if(loop_state == "loop"){
      this.first_frame();
    }else if(loop_state == "reflect"){
      this.last_frame();
      this.reverse_animation();
    }else{
      this.pause_animation();
      this.last_frame();
    }
  }
}

ScrubberWidget.prototype.anim_step_reverse = function() {
  if(this.current_frame > 0){
    this.previous_frame();
  } else {
    var loop_state = this.get_loop_state();
    if(loop_state == "loop"){
      this.last_frame();
    }else if(loop_state == "reflect"){
      this.first_frame();
      this.play_animation();
    }else{
      this.pause_animation();
      this.first_frame();
    }
  }
}

ScrubberWidget.prototype.pause_animation = function() {
  this.direction = 0;
  if (this.timer){
    clearInterval(this.timer);
    this.timer = null;
  }
}

ScrubberWidget.prototype.play_animation = function() {
  this.pause_animation();
  this.direction = 1;
  var t = this;
  if (!this.timer) this.timer = setInterval(function(){t.anim_step_forward();}, this.interval);
}

ScrubberWidget.prototype.reverse_animation = function() {
  this.pause_animation();
  this.direction = -1;
  var t = this;
  if (!this.timer) this.timer = setInterval(function(){t.anim_step_reverse();}, this.interval);
}

function extend(destination, source) {
  for (var k in source) {
    if (source.hasOwnProperty(k)) {
      destination[k] = source[k];
    }
  }
  return destination;
}

function update_widget(widget, values) {
  if (widget.hasClass("ui-slider")) {
    widget.slider('option', {
      min: 0,
      max: values.length-1,
      dim_vals: values,
      value: 0,
      dim_labels: values
    })
    widget.slider('option', 'slide').call(widget, event, {value: 0})
  } else {
    widget.empty();
    for (var i=0; i<values.length; i++){
      widget.append($("<option>", {
        value: i,
        text: values[i]
      }))
    };
    widget.data('values', values);
    widget.data('value', 0);
    widget.trigger("change");
  };
}

function init_slider(id, plot_id, dim, values, next_vals, labels, dynamic, step, value, next_dim,
                     dim_idx, delay, jQueryUI_CDN, UNDERSCORE_CDN) {
  // Slider JS Block START
  function loadcssfile(filename){
    var fileref=document.createElement("link")
    fileref.setAttribute("rel", "stylesheet")
    fileref.setAttribute("type", "text/css")
    fileref.setAttribute("href", filename)
    document.getElementsByTagName("head")[0].appendChild(fileref)
  }
  loadcssfile("https://code.jquery.com/ui/1.10.4/themes/smoothness/jquery-ui.css");
  /* Check if jQuery and jQueryUI have been loaded
     otherwise load with require.js */
  var jQuery = window.jQuery,
    // check for old versions of jQuery
    oldjQuery = jQuery && !!jQuery.fn.jquery.match(/^1\.[0-4](\.|$)/),
    jquery_path = '',
    paths = {},
    noConflict;
  var jQueryUI = jQuery.ui;
  // check for jQuery
  if (!jQuery || oldjQuery) {
    // load if it's not available or doesn't meet min standards
    paths.jQuery = jQuery;
    noConflict = !!oldjQuery;
  } else {
    // register the current jQuery
    define('jquery', [], function() { return jQuery; });
  }
  if (!jQueryUI) {
    paths.jQueryUI = jQueryUI_CDN.slice(null, -3);
  } else {
    define('jQueryUI', [], function() { return jQuery.ui; });
  }
  paths.underscore = UNDERSCORE_CDN.slice(null, -3);
  var jquery_require = {
    paths: paths,
    shim: {
      "jQueryUI": {
        exports:"$",
        deps: ['jquery']
      },
      "underscore": {
        exports: '_'
      }
    }
  }
  require.config(jquery_require);
  require(["jQueryUI", "underscore"], function(jUI, _){
    if (noConflict) $.noConflict(true);
    var vals = values;
    if (dynamic && vals.constructor === Array) {
      var default_value = parseFloat(value);
      var min = parseFloat(vals[0]);
      var max = parseFloat(vals[vals.length-1]);
      var wstep = step;
      var wlabels = [default_value];
      var init_label = default_value;
    } else {
      var min = 0;
      if (dynamic) {
        var max = Object.keys(vals).length - 1;
        var init_label = labels[value];
        var default_value = values[value];
      } else {
        var max = vals.length - 1;
        var init_label = labels[value];
        var default_value = value;
      }
      var wstep = 1;
      var wlabels = labels;
    }
    function adjustFontSize(text) {
      var width_ratio = (text.parent().width()/8)/text.val().length;
      var size = Math.min(0.9, Math.max(0.6, width_ratio))+'em';
      text.css('font-size', size);
    }
    var slider = $('#_anim_widget'+id+'_'+dim);
    slider.slider({
      animate: "fast",
      min: min,
      max: max,
      step: wstep,
      value: default_value,
      dim_vals: vals,
      dim_labels: wlabels,
      next_vals: next_vals,
      slide: function(event, ui) {
        var vals = slider.slider("option", "dim_vals");
        var next_vals = slider.slider("option", "next_vals");
        var dlabels = slider.slider("option", "dim_labels");
        if (dynamic) {
          var dim_val = ui.value;
          if (vals.constructor === Array) {
            var label = ui.value;
          } else {
            var label = dlabels[ui.value];
          }
        } else {
          var dim_val = vals[ui.value];
          var label = dlabels[ui.value];
        }
        var text = $('#textInput'+id+'_'+dim);
        text.val(label);
        adjustFontSize(text);
        HoloViews.index[plot_id].set_frame(dim_val, dim_idx);
        if (Object.keys(next_vals).length > 0) {
          var new_vals = next_vals[dim_val];
          var next_widget = $('#_anim_widget'+id+'_'+next_dim);
          update_widget(next_widget, new_vals);
        }
      }
    });
    slider.keypress(function(event) {
      if (event.which == 80 || event.which == 112) {
        var start = slider.slider("option", "value");
        var stop =  slider.slider("option", "max");
        for (var i=start; i<=stop; i++) {
          var delay = i*delay;
          $.proxy(function doSetTimeout(i) { setTimeout($.proxy(function() {
            var val = {value:i};
            slider.slider('value',i);
            slider.slider("option", "slide")(null, val);
          }, slider), delay);}, slider)(i);
        }
      }
      if (event.which == 82 || event.which == 114) {
        var start = slider.slider("option", "value");
        var stop =  slider.slider("option", "min");
        var count = 0;
        for (var i=start; i>=stop; i--) {
          var delay = count*delay;
          count = count + 1;
          $.proxy(function doSetTimeout(i) { setTimeout($.proxy(function() {
            var val = {value:i};
            slider.slider('value',i);
            slider.slider("option", "slide")(null, val);
          }, slider), delay);}, slider)(i);
        }
      }
    });
    var textInput = $('#textInput'+id+'_'+dim)
    textInput.val(init_label);
    adjustFontSize(textInput);
  });
}

function init_dropdown(id, plot_id, dim, vals, value, next_vals, labels, next_dim, dim_idx, dynamic) {
  var widget = $("#_anim_widget"+id+'_'+dim);
  widget.data('values', vals)
  for (var i=0; i<vals.length; i++){
    if (dynamic) {
      var val = vals[i];
    } else {
      var val = i;
    }
    widget.append($("<option>", {
      value: val,
      text: labels[i]
    }));
  };
  widget.data("next_vals", next_vals);
  widget.val(value);
  widget.on('change', function(event, ui) {
    if (dynamic) {
      var dim_val = parseInt(this.value);
    } else {
      var dim_val = $.data(this, 'values')[this.value];
    }
    var next_vals = $.data(this, "next_vals");
    if (Object.keys(next_vals).length > 0) {
      var new_vals = next_vals[dim_val];
      var next_widget = $('#_anim_widget'+id+'_'+next_dim);
      update_widget(next_widget, new_vals);
    }
    var widgets = HoloViews.index[plot_id]
    if (widgets) {
      widgets.set_frame(dim_val, dim_idx);
    }
  });
}


if (window.HoloViews === undefined) {
  window.HoloViews = {}
  window.PyViz = window.HoloViews
} else if (window.PyViz === undefined) {
  window.PyViz = window.HoloViews
}


var _namespace = {
  init_slider: init_slider,
  init_dropdown: init_dropdown,
  comms: {},
  comm_status: {},
  index: {},
  plot_index: {},
  kernels: {},
  receivers: {}
}

for (var k in _namespace) {
  if (!(k in window.HoloViews)) {
    window.HoloViews[k] = _namespace[k];
  }
}

// Define Bokeh specific subclasses
function BokehSelectionWidget() {
  SelectionWidget.apply(this, arguments);
}

function BokehScrubberWidget() {
  ScrubberWidget.apply(this, arguments);
}

// Let them inherit from the baseclasses
BokehSelectionWidget.prototype = Object.create(SelectionWidget.prototype);
BokehScrubberWidget.prototype = Object.create(ScrubberWidget.prototype);

// Define methods to override on widgets
var BokehMethods = {
  update_cache : function(){
    for (var index in this.frames) {
      this.frames[index] = JSON.parse(this.frames[index]);
    }
  },
  update : function(current){
    if (current === undefined) {
      return;
    }
    var data = this.frames[current];
    if (data !== undefined) {
      if (data.root in HoloViews.plot_index) {
        var doc = HoloViews.plot_index[data.root].model.document;
      } else {
        var doc = Bokeh.index[data.root].model.document;
      }
      doc.apply_json_patch(data.content);
    }
  },
  init_comms: function() {
    if (Bokeh.protocol !== undefined) {
      this.receiver = new Bokeh.protocol.Receiver()
    } else {
      this.receiver = null;
    }
    return HoloViewsWidget.prototype.init_comms.call(this);
  },
  process_msg : function(msg) {
    if (this.plot_id in HoloViews.plot_index) {
      var doc = HoloViews.plot_index[this.plot_id].model.document;
    } else {
      var doc = Bokeh.index[this.plot_id].model.document;
    }
    if (this.receiver === null) { return }
    var receiver = this.receiver;
    if (msg.buffers.length > 0) {
      receiver.consume(msg.buffers[0].buffer)
    } else {
      receiver.consume(msg.content.data)
    }
    const comm_msg = receiver.message;
    if ((comm_msg != null) && (doc != null)) {
      doc.apply_json_patch(comm_msg.content, comm_msg.buffers)
    }
  }
}

// Extend Bokeh widgets with backend specific methods
extend(BokehSelectionWidget.prototype, BokehMethods);
extend(BokehScrubberWidget.prototype, BokehMethods);

window.HoloViews.BokehSelectionWidget = BokehSelectionWidget
window.HoloViews.BokehScrubberWidget = BokehScrubberWidget
</script>
<script type="text/javascript">
    function CommManager() {
    }

    CommManager.prototype.register_target = function() {
    }

    CommManager.prototype.get_client_comm = function() {
    }

    window.PyViz.comm_manager = CommManager()
    </script>

<link rel="stylesheet" href="https://cdn.pydata.org/bokeh/release/bokeh-1.2.0.min.css">
<link rel="stylesheet" href="https://cdn.pydata.org/bokeh/release/bokeh-widgets-1.2.0.min.css">
<link rel="stylesheet" href="https://cdn.pydata.org/bokeh/release/bokeh-tables-1.2.0.min.css">
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css">
<link rel="stylesheet" href="https://code.jquery.com/ui/1.10.4/themes/smoothness/jquery-ui.css">
<style>div.bk-hbox {
    display: flex;
    justify-content: center;
}

div.bk-hbox div.bk-plot {
    padding: 8px;
}

div.bk-hbox div.bk-data-table {
    padding: 20px;
}

div.hololayout {
  display: flex;
  align-items: center;
  margin: 0;
}

div.holoframe {
  width: 75%;
}

div.holowell {
  display: flex;
  align-items: center;
}

form.holoform {
  background-color: #fafafa;
  border-radius: 5px;
  overflow: hidden;
  padding-left: 0.8em;
  padding-right: 0.8em;
  padding-top: 0.4em;
  padding-bottom: 0.4em;
  box-shadow: inset 0 1px 1px rgba(0, 0, 0, 0.05);
  margin-bottom: 20px;
  border: 1px solid #e3e3e3;
}

div.holowidgets {
  padding-right: 0;
  width: 25%;
}

div.holoslider {
  min-height: 0 !important;
  height: 0.8em;
  width: 100%;
}

div.holoformgroup {
  padding-top: 0.5em;
  margin-bottom: 0.5em;
}

div.hologroup {
  padding-left: 0;
  padding-right: 0.8em;
  width: 100%;
}

.holoselect {
  width: 92%;
  margin-left: 0;
  margin-right: 0;
}

.holotext {
  padding-left:  0.5em;
  padding-right: 0;
  width: 100%;
}

.holowidgets .ui-resizable-se {
  visibility: hidden
}

.holoframe > .ui-resizable-se {
  visibility: hidden
}

.holowidgets .ui-resizable-s {
  visibility: hidden
}


/* CSS rules for noUISlider based slider used by JupyterLab extension  */

.noUi-handle {
  width: 20px !important;
  height: 20px !important;
  left: -5px !important;
  top: -5px !important;
}

.noUi-handle:before, .noUi-handle:after {
  visibility: hidden;
  height: 0px;
}

.noUi-target {
  margin-left: 0.5em;
  margin-right: 0.5em;
}
</style><div style='display: table; margin: 0 auto;'>






  <div class="bk-root" id="51fef08e-c065-48de-bb99-829471eea7ec" data-root-id="2432"></div>

<script type="text/javascript">
  (function(root) {
  function embed_document(root) {
    
  var docs_json = {"46ef6f47-7eb4-4362-a747-ef601f4578df":{"roots":{"references":[{"attributes":{"below":[{"id":"2441","type":"CategoricalAxis"}],"center":[{"id":"2444","type":"Grid"},{"id":"2449","type":"Grid"}],"left":[{"id":"2445","type":"LinearAxis"}],"margin":null,"min_border_bottom":10,"min_border_left":10,"min_border_right":10,"min_border_top":10,"plot_width":800,"renderers":[{"id":"2465","type":"GlyphRenderer"},{"id":"2471","type":"GlyphRenderer"},{"id":"2477","type":"GlyphRenderer"},{"id":"2483","type":"GlyphRenderer"},{"id":"2489","type":"GlyphRenderer"},{"id":"2496","type":"GlyphRenderer"},{"id":"2502","type":"GlyphRenderer"}],"sizing_mode":"fixed","title":{"id":"2433","type":"Title"},"toolbar":{"id":"2455","type":"Toolbar"},"x_range":{"id":"2430","type":"FactorRange"},"x_scale":{"id":"2437","type":"CategoricalScale"},"y_range":{"id":"2431","type":"Range1d"},"y_scale":{"id":"2439","type":"LinearScale"}},"id":"2432","subtype":"Figure","type":"Plot"},{"attributes":{"source":{"id":"2467","type":"ColumnDataSource"}},"id":"2472","type":"CDSView"},{"attributes":{"bottom":{"field":"bottom"},"fill_alpha":{"value":0.1},"fill_color":{"field":"box_fill_color","transform":{"id":"2491","type":"CategoricalColorMapper"}},"line_alpha":{"value":0.1},"line_color":{"value":"black"},"top":{"field":"top"},"width":{"value":0.7},"x":{"field":"index"}},"id":"2501","type":"VBar"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"black"},"line_alpha":{"value":0.1},"line_color":{"value":"black"},"x":{"field":"index"},"y":{"field":"Salary_Range"}},"id":"2464","type":"Circle"},{"attributes":{"bottom":{"field":"bottom"},"fill_color":{"field":"box_fill_color","transform":{"id":"2491","type":"CategoricalColorMapper"}},"top":{"field":"top"},"width":{"value":0.7},"x":{"field":"index"}},"id":"2500","type":"VBar"},{"attributes":{"callback":null,"data":{"Salary_Range":{"__ndarray__":"AAAAAACAWEAAAAAAAJiAQAAAAAAAAEhAAAAAAAAAVkAAAAAAAABZQAAAAAAAAPA/AAAAAACQcEAAAAAAAIBTQAAAAAAAAE5A","dtype":"float64","shape":[9]},"index":["DevOps specialist","DevOps specialist","DevOps specialist","DevOps specialist","DevOps specialist","DevOps specialist","DevOps specialist","DevOps specialist","DevOps specialist"]},"selected":{"id":"2513","type":"Selection"},"selection_policy":{"id":"2514","type":"UnionRenderers"}},"id":"2461","type":"ColumnDataSource"},{"attributes":{},"id":"2519","type":"Selection"},{"attributes":{"dimension":1,"grid_line_color":null,"ticker":{"id":"2446","type":"BasicTicker"}},"id":"2449","type":"Grid"},{"attributes":{"data_source":{"id":"2498","type":"ColumnDataSource"},"glyph":{"id":"2500","type":"VBar"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2501","type":"VBar"},"selection_glyph":null,"view":{"id":"2503","type":"CDSView"}},"id":"2502","type":"GlyphRenderer"},{"attributes":{"fill_color":{"value":"black"},"x":{"field":"index"},"y":{"field":"Salary_Range"}},"id":"2463","type":"Circle"},{"attributes":{"x0":{"field":"x0"},"x1":{"field":"x1"},"y0":{"field":"y0"},"y1":{"field":"y1"}},"id":"2487","type":"Segment"},{"attributes":{},"id":"2515","type":"Selection"},{"attributes":{"source":{"id":"2498","type":"ColumnDataSource"}},"id":"2503","type":"CDSView"},{"attributes":{"axis_label":"Salary Range","bounds":"auto","formatter":{"id":"2507","type":"BasicTickFormatter"},"major_label_orientation":"horizontal","ticker":{"id":"2446","type":"BasicTicker"}},"id":"2445","type":"LinearAxis"},{"attributes":{"text":"Salary Box","text_color":{"value":"black"},"text_font_size":{"value":"12pt"}},"id":"2433","type":"Title"},{"attributes":{},"id":"2454","type":"ResetTool"},{"attributes":{},"id":"2526","type":"UnionRenderers"},{"attributes":{"source":{"id":"2461","type":"ColumnDataSource"}},"id":"2466","type":"CDSView"},{"attributes":{},"id":"2452","type":"WheelZoomTool"},{"attributes":{"callback":null,"data":{"bottom":{"__ndarray__":"AAAAAKB68kAAAAAAAIjzQAAAAAAAjvJAAAAAAHiJ8kAAAAAANJTyQAAAAAAA0/JAAAAAALSN8UAAAAAAgE/yQAAAAAA42ulAAAAAAJDt8UAAAAAAoHryQAAAAAAQOvJAAAAAAJDt8UAAAAAAgE/yQAAAAAA0UvNAAAAAAMD08EAAAAAA4Fj0QAAAAAD0cfJAAAAAAFCG80AAAAAAgMzyQA==","dtype":"float64","shape":[20]},"box_fill_color":["Database administrator","DevOps specialist","Full-stack developer","System administrator","Data or business analyst","Desktop or enterprise applications developer","Game or graphics developer","QA or test developer","Student","Mobile developer","Back-end developer","Front-end developer","Designer","Marketing or sales professional","Embedded applications or devices developer","Educator or academic researcher","Engineering manager","Data scientist or machine learning specialist","C-suite executive (CEO, CTO, etc.)","Product manager"],"index":["Database administrator","DevOps specialist","Full-stack developer","System administrator","Data or business analyst","Desktop or enterprise applications developer","Game or graphics developer","QA or test developer","Student","Mobile developer","Back-end developer","Front-end developer","Designer","Marketing or sales professional","Embedded applications or devices developer","Educator or academic researcher","Engineering manager","Data scientist or machine learning specialist","C-suite executive (CEO, CTO, etc.)","Product manager"],"top":{"__ndarray__":"AAAAAIAT7EAAAAAAAL3vQAAAAAAATO1AAAAAAABM7UAAAAAAAEztQAAAAABA4e1AAAAAAJD36UAAAAAAQK/sQAAAAAAATN1AAAAAAGAZ6UAAAAAAQNPsQAAAAAAA1etAAAAAAGDk6kAAAAAAANvqQAAAAABghe5AAAAAAABk6UAAAAAAgBfxQAAAAACAfOxAAAAAAFAz7kAAAAAAQOHtQA==","dtype":"float64","shape":[20]}},"selected":{"id":"2523","type":"Selection"},"selection_policy":{"id":"2524","type":"UnionRenderers"}},"id":"2492","type":"ColumnDataSource"},{"attributes":{"overlay":{"id":"2527","type":"BoxAnnotation"}},"id":"2453","type":"BoxZoomTool"},{"attributes":{},"id":"2525","type":"Selection"},{"attributes":{"factors":["Database administrator","DevOps specialist","Full-stack developer","System administrator","Data or business analyst","Desktop or enterprise applications developer","Game or graphics developer","QA or test developer","Student","Mobile developer","Back-end developer","Front-end developer","Designer","Marketing or sales professional","Embedded applications or devices developer","Educator or academic researcher","Engineering manager","Data scientist or machine learning specialist","C-suite executive (CEO, CTO, etc.)","Product manager"],"palette":["#e41a1c","#377eb8","#4daf4a","#984ea3","#ff7f00","#ffff33","#a65628","#f781bf","#999999","#e41a1c","#377eb8","#4daf4a","#984ea3","#ff7f00","#ffff33","#a65628","#f781bf","#999999","#e41a1c","#377eb8"]},"id":"2491","type":"CategoricalColorMapper"},{"attributes":{"bottom_units":"screen","fill_alpha":{"value":0.5},"fill_color":{"value":"lightgrey"},"left_units":"screen","level":"overlay","line_alpha":{"value":1.0},"line_color":{"value":"black"},"line_dash":[4,4],"line_width":{"value":2},"render_mode":"css","right_units":"screen","top_units":"screen"},"id":"2527","type":"BoxAnnotation"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"2450","type":"SaveTool"},{"id":"2451","type":"PanTool"},{"id":"2452","type":"WheelZoomTool"},{"id":"2453","type":"BoxZoomTool"},{"id":"2454","type":"ResetTool"}]},"id":"2455","type":"Toolbar"},{"attributes":{"x0":{"field":"x0"},"x1":{"field":"x1"},"y0":{"field":"y0"},"y1":{"field":"y1"}},"id":"2481","type":"Segment"},{"attributes":{"source":{"id":"2492","type":"ColumnDataSource"}},"id":"2497","type":"CDSView"},{"attributes":{},"id":"2513","type":"Selection"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"black"},"x0":{"field":"x0"},"x1":{"field":"x1"},"y0":{"field":"y0"},"y1":{"field":"y1"}},"id":"2482","type":"Segment"},{"attributes":{"callback":null,"data":{"bottom":{"__ndarray__":"AAAAAIAT7EAAAAAAAL3vQAAAAAAATO1AAAAAAABM7UAAAAAAAEztQAAAAABA4e1AAAAAAJD36UAAAAAAQK/sQAAAAAAATN1AAAAAAGAZ6UAAAAAAQNPsQAAAAAAA1etAAAAAAGDk6kAAAAAAANvqQAAAAABghe5AAAAAAABk6UAAAAAAgBfxQAAAAACAfOxAAAAAAFAz7kAAAAAAQOHtQA==","dtype":"float64","shape":[20]},"box_fill_color":["Database administrator","DevOps specialist","Full-stack developer","System administrator","Data or business analyst","Desktop or enterprise applications developer","Game or graphics developer","QA or test developer","Student","Mobile developer","Back-end developer","Front-end developer","Designer","Marketing or sales professional","Embedded applications or devices developer","Educator or academic researcher","Engineering manager","Data scientist or machine learning specialist","C-suite executive (CEO, CTO, etc.)","Product manager"],"index":["Database administrator","DevOps specialist","Full-stack developer","System administrator","Data or business analyst","Desktop or enterprise applications developer","Game or graphics developer","QA or test developer","Student","Mobile developer","Back-end developer","Front-end developer","Designer","Marketing or sales professional","Embedded applications or devices developer","Educator or academic researcher","Engineering manager","Data scientist or machine learning specialist","C-suite executive (CEO, CTO, etc.)","Product manager"],"top":{"__ndarray__":"AAAAAOCm4kAAAAAAAL3nQAAAAACgh+NAAAAAAPAb5EAAAAAAgFHkQAAAAAAAguRAAAAAAFDl3kAAAAAAgB/jQAAAAAAgz8tAAAAAACAY20AAAAAAYFjiQAAAAACA7eFAAAAAAIBU4UAAAAAAoCLiQAAAAACAg+VAAAAAAMCE20AAAAAAYOfnQAAAAAAAEeJAAAAAAGBY4kAAAAAAOITkQA==","dtype":"float64","shape":[20]}},"selected":{"id":"2525","type":"Selection"},"selection_policy":{"id":"2526","type":"UnionRenderers"}},"id":"2498","type":"ColumnDataSource"},{"attributes":{},"id":"2524","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"2479","type":"ColumnDataSource"},"glyph":{"id":"2481","type":"Segment"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2482","type":"Segment"},"selection_glyph":null,"view":{"id":"2484","type":"CDSView"}},"id":"2483","type":"GlyphRenderer"},{"attributes":{"callback":null,"data":{"x0":["Database administrator","DevOps specialist","Full-stack developer","System administrator","Data or business analyst","Desktop or enterprise applications developer","Game or graphics developer","QA or test developer","Student","Mobile developer","Back-end developer","Front-end developer","Designer","Marketing or sales professional","Embedded applications or devices developer","Educator or academic researcher","Engineering manager","Data scientist or machine learning specialist","C-suite executive (CEO, CTO, etc.)","Product manager"],"x1":["Database administrator","DevOps specialist","Full-stack developer","System administrator","Data or business analyst","Desktop or enterprise applications developer","Game or graphics developer","QA or test developer","Student","Mobile developer","Back-end developer","Front-end developer","Designer","Marketing or sales professional","Embedded applications or devices developer","Educator or academic researcher","Engineering manager","Data scientist or machine learning specialist","C-suite executive (CEO, CTO, etc.)","Product manager"],"y0":{"__ndarray__":"AAAAAPBn+EAAAAAA8Gf4QAAAAADwafhAAAAAAPBn+EAAAAAA8Gf4QAAAAADwZ/hAAAAAAPBn+EAAAAAA8Gf4QAAAAAAQvfdAAAAAAPBn+EAAAAAA8Gn4QAAAAADwafhAAAAAAPBn+EAAAAAAAO33QAAAAAAAXvhAAAAAAKAk+EAAAAAA8Gf4QAAAAADwZ/hAAAAAAPBn+EAAAAAAgPn3QA==","dtype":"float64","shape":[20]},"y1":{"__ndarray__":"AAAAAKB68kAAAAAAAIjzQAAAAAAAjvJAAAAAAHiJ8kAAAAAANJTyQAAAAAAA0/JAAAAAALSN8UAAAAAAgE/yQAAAAAA42ulAAAAAAJDt8UAAAAAAoHryQAAAAAAQOvJAAAAAAJDt8UAAAAAAgE/yQAAAAAA0UvNAAAAAAMD08EAAAAAA4Fj0QAAAAAD0cfJAAAAAAFCG80AAAAAAgMzyQA==","dtype":"float64","shape":[20]}},"selected":{"id":"2515","type":"Selection"},"selection_policy":{"id":"2516","type":"UnionRenderers"}},"id":"2467","type":"ColumnDataSource"},{"attributes":{},"id":"2516","type":"UnionRenderers"},{"attributes":{"callback":null,"factors":["Database administrator","DevOps specialist","Full-stack developer","System administrator","Data or business analyst","Desktop or enterprise applications developer","Game or graphics developer","QA or test developer","Student","Mobile developer","Back-end developer","Front-end developer","Designer","Marketing or sales professional","Embedded applications or devices developer","Educator or academic researcher","Engineering manager","Data scientist or machine learning specialist","C-suite executive (CEO, CTO, etc.)","Product manager"],"tags":[[["Developer","Developer",null]]]},"id":"2430","type":"FactorRange"},{"attributes":{"callback":null,"data":{"x0":[["Database administrator",-0.2],["DevOps specialist",-0.2],["Full-stack developer",-0.2],["System administrator",-0.2],["Data or business analyst",-0.2],["Desktop or enterprise applications developer",-0.2],["Game or graphics developer",-0.2],["QA or test developer",-0.2],["Student",-0.2],["Mobile developer",-0.2],["Back-end developer",-0.2],["Front-end developer",-0.2],["Designer",-0.2],["Marketing or sales professional",-0.2],["Embedded applications or devices developer",-0.2],["Educator or academic researcher",-0.2],["Engineering manager",-0.2],["Data scientist or machine learning specialist",-0.2],["C-suite executive (CEO, CTO, etc.)",-0.2],["Product manager",-0.2]],"x1":[["Database administrator",0.2],["DevOps specialist",0.2],["Full-stack developer",0.2],["System administrator",0.2],["Data or business analyst",0.2],["Desktop or enterprise applications developer",0.2],["Game or graphics developer",0.2],["QA or test developer",0.2],["Student",0.2],["Mobile developer",0.2],["Back-end developer",0.2],["Front-end developer",0.2],["Designer",0.2],["Marketing or sales professional",0.2],["Embedded applications or devices developer",0.2],["Educator or academic researcher",0.2],["Engineering manager",0.2],["Data scientist or machine learning specialist",0.2],["C-suite executive (CEO, CTO, etc.)",0.2],["Product manager",0.2]],"y0":[99967.0,99967.0,99999.0,99967.0,99967.0,99967.0,99967.0,99967.0,97233.0,99967.0,99999.0,99999.0,99967.0,98000.0,99808.0,98890.0,99967.0,99967.0,99967.0,98200.0],"y1":[99967.0,99967.0,99999.0,99967.0,99967.0,99967.0,99967.0,99967.0,97233.0,99967.0,99999.0,99999.0,99967.0,98000.0,99808.0,98890.0,99967.0,99967.0,99967.0,98200.0]},"selected":{"id":"2521","type":"Selection"},"selection_policy":{"id":"2522","type":"UnionRenderers"}},"id":"2485","type":"ColumnDataSource"},{"attributes":{"source":{"id":"2479","type":"ColumnDataSource"}},"id":"2484","type":"CDSView"},{"attributes":{},"id":"2522","type":"UnionRenderers"},{"attributes":{"bottom":{"field":"bottom"},"fill_color":{"field":"box_fill_color","transform":{"id":"2491","type":"CategoricalColorMapper"}},"top":{"field":"top"},"width":{"value":0.7},"x":{"field":"index"}},"id":"2494","type":"VBar"},{"attributes":{"source":{"id":"2485","type":"ColumnDataSource"}},"id":"2490","type":"CDSView"},{"attributes":{"x0":{"field":"x0"},"x1":{"field":"x1"},"y0":{"field":"y0"},"y1":{"field":"y1"}},"id":"2475","type":"Segment"},{"attributes":{"data_source":{"id":"2485","type":"ColumnDataSource"},"glyph":{"id":"2487","type":"Segment"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2488","type":"Segment"},"selection_glyph":null,"view":{"id":"2490","type":"CDSView"}},"id":"2489","type":"GlyphRenderer"},{"attributes":{},"id":"2521","type":"Selection"},{"attributes":{"data_source":{"id":"2492","type":"ColumnDataSource"},"glyph":{"id":"2494","type":"VBar"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2495","type":"VBar"},"selection_glyph":null,"view":{"id":"2497","type":"CDSView"}},"id":"2496","type":"GlyphRenderer"},{"attributes":{},"id":"2437","type":"CategoricalScale"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"black"},"x0":{"field":"x0"},"x1":{"field":"x1"},"y0":{"field":"y0"},"y1":{"field":"y1"}},"id":"2476","type":"Segment"},{"attributes":{},"id":"2439","type":"LinearScale"},{"attributes":{},"id":"2523","type":"Selection"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"black"},"x0":{"field":"x0"},"x1":{"field":"x1"},"y0":{"field":"y0"},"y1":{"field":"y1"}},"id":"2488","type":"Segment"},{"attributes":{"data_source":{"id":"2473","type":"ColumnDataSource"},"glyph":{"id":"2475","type":"Segment"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2476","type":"Segment"},"selection_glyph":null,"view":{"id":"2478","type":"CDSView"}},"id":"2477","type":"GlyphRenderer"},{"attributes":{},"id":"2514","type":"UnionRenderers"},{"attributes":{},"id":"2442","type":"CategoricalTicker"},{"attributes":{"callback":null,"data":{"x0":[["Database administrator",-0.2],["DevOps specialist",-0.2],["Full-stack developer",-0.2],["System administrator",-0.2],["Data or business analyst",-0.2],["Desktop or enterprise applications developer",-0.2],["Game or graphics developer",-0.2],["QA or test developer",-0.2],["Student",-0.2],["Mobile developer",-0.2],["Back-end developer",-0.2],["Front-end developer",-0.2],["Designer",-0.2],["Marketing or sales professional",-0.2],["Embedded applications or devices developer",-0.2],["Educator or academic researcher",-0.2],["Engineering manager",-0.2],["Data scientist or machine learning specialist",-0.2],["C-suite executive (CEO, CTO, etc.)",-0.2],["Product manager",-0.2]],"x1":[["Database administrator",0.2],["DevOps specialist",0.2],["Full-stack developer",0.2],["System administrator",0.2],["Data or business analyst",0.2],["Desktop or enterprise applications developer",0.2],["Game or graphics developer",0.2],["QA or test developer",0.2],["Student",0.2],["Mobile developer",0.2],["Back-end developer",0.2],["Front-end developer",0.2],["Designer",0.2],["Marketing or sales professional",0.2],["Embedded applications or devices developer",0.2],["Educator or academic researcher",0.2],["Engineering manager",0.2],["Data scientist or machine learning specialist",0.2],["C-suite executive (CEO, CTO, etc.)",0.2],["Product manager",0.2]],"y0":[8.0,1540.0,1.0,1.0,1.0,12.0,8.0,24.0,1.0,5.0,1.0,4.0,12.0,50.0,12.0,1.0,24.0,4.0,1.0,1.0],"y1":[8.0,1540.0,1.0,1.0,1.0,12.0,8.0,24.0,1.0,5.0,1.0,4.0,12.0,50.0,12.0,1.0,24.0,4.0,1.0,1.0]},"selected":{"id":"2519","type":"Selection"},"selection_policy":{"id":"2520","type":"UnionRenderers"}},"id":"2479","type":"ColumnDataSource"},{"attributes":{"source":{"id":"2473","type":"ColumnDataSource"}},"id":"2478","type":"CDSView"},{"attributes":{},"id":"2520","type":"UnionRenderers"},{"attributes":{"axis_label":"Developer","bounds":"auto","formatter":{"id":"2505","type":"CategoricalTickFormatter"},"major_label_orientation":1.5707963267948966,"ticker":{"id":"2442","type":"CategoricalTicker"}},"id":"2441","type":"CategoricalAxis"},{"attributes":{"callback":null,"data":{"x0":["Database administrator","DevOps specialist","Full-stack developer","System administrator","Data or business analyst","Desktop or enterprise applications developer","Game or graphics developer","QA or test developer","Student","Mobile developer","Back-end developer","Front-end developer","Designer","Marketing or sales professional","Embedded applications or devices developer","Educator or academic researcher","Engineering manager","Data scientist or machine learning specialist","C-suite executive (CEO, CTO, etc.)","Product manager"],"x1":["Database administrator","DevOps specialist","Full-stack developer","System administrator","Data or business analyst","Desktop or enterprise applications developer","Game or graphics developer","QA or test developer","Student","Mobile developer","Back-end developer","Front-end developer","Designer","Marketing or sales professional","Embedded applications or devices developer","Educator or academic researcher","Engineering manager","Data scientist or machine learning specialist","C-suite executive (CEO, CTO, etc.)","Product manager"],"y0":{"__ndarray__":"AAAAAAAAIEAAAAAAABCYQAAAAAAAAPA/AAAAAAAA8D8AAAAAAADwPwAAAAAAAChAAAAAAAAAIEAAAAAAAAA4QAAAAAAAAPA/AAAAAAAAFEAAAAAAAADwPwAAAAAAABBAAAAAAAAAKEAAAAAAAABJQAAAAAAAAChAAAAAAAAA8D8AAAAAAAA4QAAAAAAAABBAAAAAAAAA8D8AAAAAAADwPw==","dtype":"float64","shape":[20]},"y1":{"__ndarray__":"AAAAAOCm4kAAAAAAAL3nQAAAAACgh+NAAAAAAPAb5EAAAAAAgFHkQAAAAAAAguRAAAAAAFDl3kAAAAAAgB/jQAAAAAAgz8tAAAAAACAY20AAAAAAYFjiQAAAAACA7eFAAAAAAIBU4UAAAAAAoCLiQAAAAACAg+VAAAAAAMCE20AAAAAAYOfnQAAAAAAAEeJAAAAAAGBY4kAAAAAAOITkQA==","dtype":"float64","shape":[20]}},"selected":{"id":"2517","type":"Selection"},"selection_policy":{"id":"2518","type":"UnionRenderers"}},"id":"2473","type":"ColumnDataSource"},{"attributes":{},"id":"2518","type":"UnionRenderers"},{"attributes":{"x0":{"field":"x0"},"x1":{"field":"x1"},"y0":{"field":"y0"},"y1":{"field":"y1"}},"id":"2469","type":"Segment"},{"attributes":{"bottom":{"field":"bottom"},"fill_alpha":{"value":0.1},"fill_color":{"field":"box_fill_color","transform":{"id":"2491","type":"CategoricalColorMapper"}},"line_alpha":{"value":0.1},"line_color":{"value":"black"},"top":{"field":"top"},"width":{"value":0.7},"x":{"field":"index"}},"id":"2495","type":"VBar"},{"attributes":{},"id":"2446","type":"BasicTicker"},{"attributes":{},"id":"2450","type":"SaveTool"},{"attributes":{"data_source":{"id":"2461","type":"ColumnDataSource"},"glyph":{"id":"2463","type":"Circle"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2464","type":"Circle"},"selection_glyph":null,"view":{"id":"2466","type":"CDSView"}},"id":"2465","type":"GlyphRenderer"},{"attributes":{"grid_line_color":null,"ticker":{"id":"2442","type":"CategoricalTicker"}},"id":"2444","type":"Grid"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"black"},"x0":{"field":"x0"},"x1":{"field":"x1"},"y0":{"field":"y0"},"y1":{"field":"y1"}},"id":"2470","type":"Segment"},{"attributes":{},"id":"2505","type":"CategoricalTickFormatter"},{"attributes":{},"id":"2451","type":"PanTool"},{"attributes":{},"id":"2507","type":"BasicTickFormatter"},{"attributes":{"callback":null,"end":99999.0,"reset_end":99999.0,"reset_start":1.0,"start":1.0,"tags":[[["Salary Range","Salary Range",null]]]},"id":"2431","type":"Range1d"},{"attributes":{},"id":"2517","type":"Selection"},{"attributes":{"data_source":{"id":"2467","type":"ColumnDataSource"},"glyph":{"id":"2469","type":"Segment"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2470","type":"Segment"},"selection_glyph":null,"view":{"id":"2472","type":"CDSView"}},"id":"2471","type":"GlyphRenderer"}],"root_ids":["2432"]},"title":"Bokeh Application","version":"1.2.0"}};
  var render_items = [{"docid":"46ef6f47-7eb4-4362-a747-ef601f4578df","roots":{"2432":"51fef08e-c065-48de-bb99-829471eea7ec"}}];
  root.Bokeh.embed.embed_items_notebook(docs_json, render_items);

  }
  if (root.Bokeh !== undefined) {
    embed_document(root);
  } else {
    var attempts = 0;
    var timer = setInterval(function(root) {
      if (root.Bokeh !== undefined) {
        embed_document(root);
        clearInterval(timer);
      }
      attempts++;
      if (attempts > 100) {
        console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
        clearInterval(timer);
      }
    }, 10, root)
  }
})(window);
</script>
</div>